#!/bin/bash
set -e

ICON_SCRIPTS="$(dirname $0)"
ICON_WORK={{ dwd_icon_workdir | quote }}

TARGET_GRID_DESCRIPTION="$ICON_SCRIPTS/target_grid_description.txt"
ICON_GRID_FILE={{ dwd_icon_grid_file | quote }}
ICON_GRID_PATH="$ICON_WORK/$ICON_GRID_FILE"
WEIGHTS_FILE="$ICON_WORK/target_weights.nc"

mkdir -p "$ICON_WORK"

if test ! -f "$WEIGHTS_FILE" ; then
    if test ! -f "$ICON_GRID_PATH" ; then
        curl -sL {{ dwd_icon_grid_url | quote }} | bunzip2 > "$ICON_GRID_PATH"
    fi
    cdo "gennn,$TARGET_GRID_DESCRIPTION" "$ICON_GRID_PATH" "$WEIGHTS_FILE"

    # remove grid file only if it is older than a week to allow tuning the grid description
    find "$ICON_GRID_PATH" -mtime +7 -exec rm -vf \{\} \;
fi

if test -f "$2" ; then
    echo "cdo output file '$2' exists"
    exit 0
fi

if test ! -f "$1" ; then
    echo "cdo input file '$1' is missing"
    exit 1
fi

exec cdo -f grb2 "remap,$TARGET_GRID_DESCRIPTION,$WEIGHTS_FILE" "$1" "$2"
